var i18n = require('i18next');
var XHR = require('i18next-xhr-backend');
var LanguageDetector = require('i18next-browser-languagedetector');

var options = {
  fallbackLng: 'en',
  load: 'languageOnly',
  debug: true,
  saveMissing: false,
  backend: {
    loadPath: '/Translations/get?lng={{lng}}&ns={{ns}}',
    defaultNS: 'Common',
    addPath: '/Translations/add?lng={{lng}}&ns={{ns}}',
    crossDomain: true,
    allowMultiLoading: true
  },
  react: {
    wait: false,
    exposeNamespace: true
  },
  interpolation: {
    escapeValue: false,
    formatSeparator: ',',
    format: function format(value, _format, lng) {
      return "1";
      if (_format === 'uppercase') return value.toUpperCase();
      return value;
    }
  }
};

if (process.browser) {
  i18n.use(XHR);
  // .use(Cache)
  //.use(LanguageDetector);
}



if(typeof(document)=='undefined') {
  var i18nInstance = i18n;
} else {
  var i18nInstance = i18n.default;
}
export default i18nInstance;

export function init(overwrite) {
  var combinedOptions = { ...options, ...overwrite };
  if (!i18n.isInitialized) i18n.init(combinedOptions);
};