import fs from 'fs';
import Handlebars from 'handlebars';

export default class ViewRenderer {

  constructor(props) {
    this.filePath = props.filePath;
    this.data = props.data;
  }

  render() {
    return new Promise((fulfill, reject) => {
      fs.readFile(`${this.filePath}.handlebars`, 'utf8', (err, source) => {
        if (err)  {
          reject(err)
        } else {
          let template = Handlebars.compile(source);
          fulfill(template(this.data));
        }
      });
    });
  }
}